#include <stdio.h>
#include <stdlib.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#define SCREEN_WIDTH    600
#define SCREEN_HEIGHT   600

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Sandpiles", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    static int table[2][SCREEN_WIDTH][SCREEN_HEIGHT];
    int currentTable = 0;

    // initialise the table
    for (int y = 0; y < SCREEN_HEIGHT; ++y)
        for (int x = 0; x < SCREEN_WIDTH; ++x)
            table[currentTable][x][y] = 0;

    table[currentTable][SCREEN_WIDTH / 2][SCREEN_HEIGHT / 2] = 400000;

    // init palette
    Color palette[5];
    palette[0] = Color(0, 0, 255);
    palette[1] = Color(0, 255, 255);
    palette[2] = Color(255, 255, 0);
    palette[3] = Color(255, 0, 0);
    palette[4] = Color(255, 255, 255);

    while (sys.isQuitRequested() == false)
    {
        // draw the current table
        for (int y = 0; y < SCREEN_HEIGHT; ++y)
            for (int x = 0; x < SCREEN_WIDTH; ++x)
            {
                int color = table[currentTable][x][y];

                if (color > 4)
                    color = 4;
                gfx.setPixel(x, y, palette[color]);
            }

        gfx.render();
        sys.processEvents();

        // update the table
        for (int y = 0; y < SCREEN_HEIGHT; ++y)
            for (int x = 0; x < SCREEN_WIDTH; ++x)
            {
                table[1 - currentTable][x][y] = table[currentTable][x][y];
            }

        for (int y = 0; y < SCREEN_HEIGHT; ++y)
            for (int x = 0; x < SCREEN_WIDTH; ++x)
            {
                if (table[currentTable][x][y] >= 4)
                {
                    table[1 - currentTable][x][y] -= 4;

                    if (x - 1 >= 0)
                        table[1 - currentTable][x - 1][y] += 1;

                    if (x + 1 < SCREEN_WIDTH)
                        table[1 - currentTable][x + 1][y] += 1;

                    if (y - 1 >= 0)
                        table[1 - currentTable][x][y - 1] += 1;

                    if (y + 1 < SCREEN_HEIGHT)
                        table[1 - currentTable][x][y + 1] += 1;
                }
            }

        currentTable = 1 - currentTable;
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
